2022-03-21  Karl Berry  <karl@tug.org>

	* TL'22 release.

2022-02-20  Hironobu Yamashita  <h.y.acetaminophen@gmail.com>

	* pbibtex.ch: Improve substring$ to truncate at least one
	  character when trying to start counting from the middle
	  byte of the first or last Japanese character.
	  Still version j0.34.
	  https://github.com/texjporg/tex-jp-build/issues/133

2022-02-15  Hironori Kitagawa  <h_kitagawa2001@yahoo.co.jp>

	* ptex-base.ch: Revised state after a control word which ends
	  with a Japanese character. Starting from pTeX version p4.0.0,
	  newline char after "a control word ending with a Japanese
	  character + {}" is ignored. To emulate older behavior, a new
	  primitive \ptexlineendmode is added.
	  The new primitive is an internal integer which means:
	   - When the least significant bit is set,
	     a blank is generated when the line ends with
	     "a control word ending with a Japanese character + {}".
	   - When the second least significant bit is set,
	     a blank is generated when the line ends with
	     "a Japanese control symbol".
	   - When the third least significant bit is set,
	     a blank is generated when the line ends with
	     "a Japanese character (which is not part of a CS) + {}".
	  By setting \ptexlineendmode to the following values,
	  old versions of pTeX can be restored:
	   - p4.0.0 or later : default 0.
	   - p3.8.2-3.10.0   : similar to 1.
	   - p3.8.1 or older : similar to 3.
	  More info: https://github.com/texjporg/tex-jp-build/issues/87

2022-02-13  Hironobu Yamashita  <h.y.acetaminophen@gmail.com>

	* ptex-base.ch: \write18 in '^^' format. (Thanks Yukimasa Morimi)
	* pbibtex.ch: Do not break at white_space after Japanese
	  characters. Version j0.34.
	  https://github.com/texjporg/pbibtex-manual/issues/1

2022-02-05  Hironori Kitagawa  <h_kitagawa2001@yahoo.co.jp>

	* ptex-base.ch: Fix for \write18 with quotation.
	  Convert non-Japanese non-ASCII bytes in name_of_file to
	  "^^" format. (Thanks Yukimasa Morimi)
	* ptex.defines: Add isinternalUPTEX and isterminalUTF8.

2022-01-29  Hironobu Yamashita  <h.y.acetaminophen@gmail.com>

	* ptex-base.ch: Fix \chardef code 256 in math.
	  Fix \mathcode for 128--255 not working.
	  https://github.com/texjporg/tex-jp-build/issues/129

2022-01-27  Hironori Kitagawa  <h_kitagawa2001@yahoo.co.jp>

	* ptex-base.ch: Fix a mistake and avoid compiler warnings.

2022-01-22  Hironori Kitagawa  <h_kitagawa2001@yahoo.co.jp>

	* ptex-base.ch: Change type of str_pool to unsigned short.
	  We use only 0--511, and use flag 0x100 for Japanese char.
	  More details in TUGboat 41(2):329--334, 2020.
	* kanji.h: Adapt to arguments of input_line2() in ptexenc-1.4.0
	  (for pBibTeX).
	* ptex.defines: Add multistrlen{short,filename}, fromBUFFshort.
	* ptex_version.h: Version p4.0.0.
	* tests/filename_test.sh, tests/printkanji.tex: Added.
	  https://github.com/texjporg/tex-jp-build/issues/81

2022-01-10  Karl Berry  <karl@freefriends.org>

	* am/ptex.am: do not silence tangle-sh.

2021-07-01  Hironobu Yamashita  <h.y.acetaminophen@gmail.com>

	* ptex-base.ch: Set subtype=0 for adjust_node.

2021-06-29  Hironori Kitagawa  <h_kitagawa2001@yahoo.co.jp>
	and Hironobu Yamashita  <h.y.acetaminophen@gmail.com>

	* ptex-base.ch:
	  - Bug fix: Wrap print_hex for negative value.
	  - Change: Code conversion primitives return -1 for invalid.
	  - Added: New primitives \ucs (from upTeX) and \toucs.
	* ptex.defines: Add fromUCS() and toUCS().
	* ptex_version.h: pTeX version p3.10.0.
	https://github.com/texjporg/tex-jp-build/pull/121

2021-06-25  Hironori Kitagawa  <h_kitagawa2001@yahoo.co.jp>
	and Hironobu Yamashita  <h.y.acetaminophen@gmail.com>

	* ptex-base.ch (end_graf, @<Go into display math mode@>):
	Ignore disp_node-only paragraphs.
	* ptex-base.ch (line_break): consider when link(temp_head)=tail
	and it is a disp_node.
	https://github.com/texjporg/tex-jp-build/issues/123
	* ptex-base.ch: Partially revert the commit on 2019-05-06;
	no re-eval kcatcode of \let-copied Japanese character token in
	\if and \ifcat, because the behavior was inconsistent against \ifx.
	https://github.com/texjporg/ptex-manual/issues/4
	* ptex-base.ch: Fix searching in inhibit/kinsoku tables, because
	the fix on 2018-04-14 was still incomplete. More information for
	\tracingrestores and \tracingassigns.
	https://github.com/texjporg/tex-jp-build/issues/113
	* tests/kinsoku_search.tex: New test file.
	* tests/kinsoku_table.tex: Update.
	* ptex-base.ch, ptex_version.h: Version p3.9.1.

2021-03-23  Karl Berry  <karl@tug.org>

	* TL'21.

2021-02-18  Hironori Kitagawa  <h_kitagawa2001@yahoo.co.jp>

	* ptex-base.ch, ptex_version.h: pTeX version p3.9.0 for TL21.
	(Forgot to update version number on 2020-02-05.)

2021-02-15  Andreas Scherer  <https://ascherer.github.io>

	* ptexdir/ptex-base.ch: Fix Pascal variable in comment.

2020-11-29  Hironobu Yamashita  <h.y.acetaminophen@gmail.com>

	* ptex-base.ch: Fix syntax error of "not equal".
	Correct error recovery value of illegal catcode for upTeX.

2020-10-30  Hironobu Yamashita  <h.y.acetaminophen@gmail.com>

	* pdvitype.ch: Strict check for DVI ID was wrong for
	output-level <= 3; needs reconsider.

2020-08-29  Hironobu Yamashita  <h.y.acetaminophen@gmail.com>

	* pdvitype.ch: Support dtou direction. Strict check for DVI ID
	with command 255. Version p0.5.

2020-05-17  Hironobu Yamashita  <h.y.acetaminophen@gmail.com>

	* ppltotf.ch: Avoid compiler warnings: equality comparison with
	extraneous parentheses.

2020-05-05  Hironori Kitagawa  <h_kitagawa2001@yahoo.co.jp>

	* ptex-base.ch: Improved resetting inhibit_glue_flag in extensions.
	https://github.com/texjporg/tex-jp-build/pull/102

2020-02-09  Phelype Oleinik  <phe.h.o1@gmail.com>

	* ptexdir/ptex-base.ch: extra end; needed for the scan_file_name
	change in tex.ch.

2020-02-09  Hironori Kitagawa  <h_kitagawa2001@yahoo.co.jp>

	* ptex-base.ch: forgot to set cur_val_level in fetching
	\kansujichar (Bug introduced in commit on 2019-10-14).

2020-02-05  Hironobu Yamashita  <h.y.acetaminophen@gmail.com>

	* ptex-base.ch: Add new primitives \ifjfont and \iftfont.

2019-12-10  Hironori Kitagawa  <h_kitagawa2001@yahoo.co.jp>

	* am/ptex.am (ptex_cppflags): append $(ZLIB_INCLUDES).
	(ptex_ldadd): append $(ZLIB_LIBS.)
	(ptex_dependencies): append $(ZLIB_DEPEND) 
	(ptex_web_srcs): append zlib-fmt.ch.
	* kanji.h: #include <zlib.h>
	(dump_kanji, undump_kanji): arg is now type gzFile instead of FILE *.
	* kanji_dump.c (pTeX) [!pTeX]: #define if not already.
	(dump_kanji, undump_kanji): chang arg type.
	* zfmtcompress.test: new script (not enabled).

2019-10-14  Hironobu Yamashita  <h.y.acetaminophen@gmail.com>

	* ptex-base.ch: Allow getting \kansujichar.
	* ptex_version.h: pTeX version p3.8.3.

2019-08-04  Hironobu Yamashita  <h.y.acetaminophen@gmail.com>

	* ppltotf.ch: 'This property name doesn't belong in a TYPE list'
	was never available.

2019-06-24  Hironobu Yamashita  <h.y.acetaminophen@gmail.com>

	* ptex-base.ch: 'Improper alphabetic or KANJI constant' error
	should be raised for multibyte CS.
	* tests/let_char_token.tex: Added.

2019-05-28  Hironobu Yamashita  <h.y.acetaminophen@gmail.com>

	* am/ptex.am: Add a new test.
	* pver.test: New test file for version number consistency.
	* tests/pver1.tex, ptexdir/tests/pver2.tex: New.

2019-05-06  Hironori Kitagawa  <h_kitagawa2001@yahoo.co.jp>

	* ptex-base.ch:
	Make appropriate comparison of U+0100 by \if in upTeX.
	https://github.com/texjporg/tex-jp-build/issues/68
	Re-eval kcatcode of Japanese character token in \if and \ifcat.
	https://github.com/texjporg/ptex-manual/issues/4

2019-02-03  Hironori Kitagawa  <h_kitagawa2001@yahoo.co.jp>

	* ptex-base.ch: Ignore newline char after Japanese control
	symbol. https://github.com/texjporg/tex-jp-build/issues/37
	* tests/control_symbol.tex: More test cases.
	* ptex_version.h: pTeX version p3.8.2.

2019-02-03  Hironori Kitagawa  <h_kitagawa2001@yahoo.co.jp>
	and Hironobu Yamashita  <h.y.acetaminophen@gmail.com>

	* ptex-base.ch: Change the behavior of \inhibitglue. See
	  https://github.com/texjporg/tex-jp-build/issues/28.
	  - \inhibitglue becomes ineffective when it encounters a node.
	    (former commit on 2014-05-06 was still insufficient.)
	  - non-expandable tokens without node (e.g. \relax, assignment)
	    becomes transparent.
	  - \inhibitglue inside a list does not affect another list.
	  - Add new primitive \disinhibitglue to reset the inhibit glue
	    flag explicitly.
	* tests/inhibitglue.tex: Added.

2019-02-03  Hironobu Yamashita  <h.y.acetaminophen@gmail.com>

	* kanji.h: Use fputs2() to benefit from kanji encoding conversion.
	https://github.com/texjporg/tex-jp-build/issues/34

2019-01-23  Hironobu Yamashita  <h.y.acetaminophen@gmail.com>

	* ptex-base.ch: Add dump_kanji and undump_kanji.
	* ptex.defines: Add dumpkanji and undumpkanji.
	* kanji.c: Factor out init_kanji().
	* kanji_dump.c: New file for dumping/undumping kanji encoding.
	* kanji.h: Add init_kanji(), dump_kanji(), and undump_kanji().
	* am/ptex.am (libkanji_a_SOURCES): Add kanji_dump.c.
	(all changes based on tl r23753 of upTeX, dated 2011-08-29.)

	* kanji_dump.c: Throw a warning when kanji internal encoding
	is incompatible with the preloaded format.
	https://github.com/texjporg/tex-jp-build/issues/55

2018-09-09  Karl Berry  <karl@tug.org>

	* ptriptest.test: LC_ALL=LANGUAGE=C.

2018-06-14  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* pbibtex.ch, pdvitype.ch, ppltotf.ch, ptftopl.ch,
	kanji.h, kanji.c, ptex.defines: remove sjisterminal (w32 only).

2018-05-06  Hironori Kitagawa  <h_kitagawa2001@yahoo.co.jp>

	* kanji.c: More strict check kanji token.

2018-04-14  Hironori Kitagawa  <h_kitagawa2001@yahoo.co.jp>

	* ptex-base.ch: Fix issue GitHub:texjporg/tex-jp-build#57
	  that discontinuous KINSOKU/INHIBIT table cannot be
	  searched properly.
	  (regression caused by a commmit of 2017-09-11)
	* tests/free_pena.tex, tests/free_ixsp.tex: Added.
	* ptex_version.h: pTeX version p3.8.1.

2018-02-05  Hironobu Yamashita  <h.y.acetaminophen@gmail.com>

	* ptex-base.ch: Set subtype for JFM glue in math list.

2018-02-02  Hironobu Yamashita  <h.y.acetaminophen@gmail.com>

	* ppltotf.ch: Fix issues GitHub:texjporg/tex-jp-build#47, #48
	 - Support SKIP property in GLUEKERN table.
	 - Improve hex charcode parsing.
	* ptftopl.ch: Fix issue GitHub:texjporg/tex-jp-build#48
	 - Print ASCII characters always in hex charcode (for upTFtoPL).
	* ptex-base.ch: Fix issue GitHub:texjporg/tex-jp-build#47
	 - Support SKIP property in GLUEKERN table.
	 - Support huge GLUEKERN table with rearrangement.
	* am/ptex.am: Add new tests.
	* skipjfm.test, tests/skipjfm.{tex,pl,tfm}: New test files.

2018-01-31  Hironori Kitagawa  <h_kitagawa2001@yahoo.co.jp>

	* ptex-base.ch: Fix issue GitHub:texjporg/tex-jp-build#40
	 - Insert a disp_node before the first character in a
	   paragraph or an hbox, if disp_node is not inserted yet
	   in the current list (in case it is unboxed).
	 - Inhibit JFM glue after a disp_node at the very beginning of
	   a paragraph or an hbox.
	* tests/disp_jfm.tex, tests/disp_unbox.tex: Added.

2018-01-27  Hironobu Yamashita  <h.y.acetaminophen@gmail.com>

	* ppltotf.ch, ptftopl.ch: Introduce a new JFM spec, to allow
	3-byte characters in TYPE > 0 for upTeX. The new spec is
	effectively upper compatible with the original one.
	* ptex-base.ch, pdvitype.ch: Adapt to the new JFM spec.

2018-01-21  Hironori Kitagawa  <h_kitagawa2001@yahoo.co.jp>

	* ptex-base.ch: New primitives: \ptexversion, \ptexminorversion
	and \ptexrevision.
	* ptex_version.h: pTeX version p3.8.0.

2017-12-21  Hironori Kitagawa  <h_kitagawa2001@yahoo.co.jp>

	* ptex-base.ch: Include zw etc. in "Dimensions can be in units ..."
	help message.

2017-11-30  Hironori Kitagawa  <h_kitagawa2001@yahoo.co.jp>

	* ptex-base.ch: Suppress a space character printed after the name
	of a multibyte control symbol in print_cs().
	* tests/control-symbol.tex: Added.

2017-10-04  Hironori Kitagawa  <h_kitagawa2001@yahoo.co.jp>

	* ptex-base.ch: Direction check in \discretionary.

2017-09-11  Hironori Kitagawa  <h_kitagawa2001@yahoo.co.jp>

	* ptex-base.ch: Assigning the default value frees the KINSOKU table
	and inhibit table, only if global or \currentgrouplevel=0.
	* tests/kinsoku_table.tex: Added.

2017-09-09  Hironori Kitagawa  <h_kitagawa2001@yahoo.co.jp>

	* ptex-base.ch: Remove JFM glue after kinsoku penalty at the top
	of list in adjust_hlist. Do not insert kinsoku penalty when it is
	set to zero.

2017-09-09  Hironobu Yamashita  <h.y.acetaminophen@gmail.com>

	* ptftopl.ch: Check for fifth byte (= upper byte of lf) of input JFM.

2017-09-07  Hironori Kitagawa  <h_kitagawa2001@yahoo.co.jp>

	* ptex-base.ch: More restrictions on direction change commands.
	 - Direction change is not allowed in unrestricted horizontal mode,
	   nor math modes.
	 - In external vertical mode, direction change is allowed only if
	   both the current page nor recent contributions do not contain
	   any boxes and rules.
	* ptex_version.h: pTeX version p3.7.2.

2017-04-24  Hironori Kitagawa  <h_kitagawa2001@yahoo.co.jp>

	* ptex-base.ch: p\TeX -> \pTeX.

2017-04-09  Hironori Kitagawa  <h_kitagawa2001@yahoo.co.jp>

	* ptex-base.ch: Fix a bug in single-letter control sequence
	when \endlinechar=-1.
	* tests/endlinechar.tex: Added.

2017-04-06  Hironori Kitagawa  <h_kitagawa2001@yahoo.co.jp>

	* ptex-base.ch: Fix a bug that the postbreakpenalty sometimes reappears
	even when it was removed by \unpenalty.
	* tests/postpena.tex: Added.

2017-03-12  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* ptex-base.ch: Fix a typo pointed out at
	https://github.com/clerkma/ptex-ng/issues/19.

2017-02-05  TANAKA Takuji  <ttk@t-lab.opal.ne.jp>

	* ppltotf.ch: Expand the limit of glue/kern and kern tables.

2016-12-16  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* pbibtex.ch, pdvitype.ch, ppltotf.ch, ptftopl.ch:
	Use "issue@texjp.org" as bug_email in usagehelp().

2016-12-15  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* ptexextra.h: Use "issue@texjp.org" as BUG_ADDRESS.

2016-09-12  Hironori Kitagawa  <h_kitagawa2001@yahoo.co.jp>

	* ptex-base.ch: New primitive \ifmbox to realize better box in math mode.

2016-09-06  Hironori Kitagawa  <h_kitagawa2001@yahoo.co.jp>

	* ptex-base.ch: Allow only 8bit arguments for \catcode etc.

2016-06-06  Hironori Kitagawa  <h_kitagawa2001@yahoo.co.jp>

	* ptex-base.ch: Fix a bug in check_box().
	ptex_version.h: pTeX version p3.7.1.

2016-03-04  Hironori Kitagawa  <h_kitagawa2001@yahoo.co.jp>

	* ptex-base.ch: Add new primitives \textbaselineshiftfactor (=1000),
	\scriptbaselineshiftfactor (=700), \scriptscriptbaselineshiftfactor (=500)
	to improve typesetting with non-vanishing \ybaselineshift.
	If all three are zero, the old features are recovered.

2015-09-22  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* ptriptest.test: Also check tripos.tex.

2015-09-10  Hironori Kitagawa  <h_kitagawa2001@yahoo.co.jp>

	* ptex-base.ch: Fix a bug in flushing choice node.
	* ptex_version.h: pTeX version p3.7.

2015-07-10  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* ptriptest (removed): Renamed ...
	* ptriptest.test (new):  ... into this.
	* am/ptex.am: Better dependencies for 'make check'.

2015-06-22  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* am/ptex.am: Use $(tie_c) and $(tie_m).

2015-04-12  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* ptrip/ptrip.diffs: Updated for TL 2015.

2015-03-14  Karl Berry  <karl@tug.org>

	* ptex-base.ch (pTeX_version_string): bump to 3.6 (per Akira).

2015-01-18  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* pdvitype.ch: Drop intcast().

2015-01-12  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* ptftopl.ch: Use ^byte and xmalloc_array().

2014-12-12  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* ptriptest: Complain early if trip.fmt is not created.
	Inspired by report from vvv, tlbuild 14 Jun 2011 10:25:47.

2014-05-06  Hironori Kitagawa  <h_kitagawa2001@yahoo.co.jp>

	* ptex-base.ch: reset inhibit_glue_flag in several places
	where it was missing.

2014-05-02  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* ptrip/ptrip.diffs: Updated for TL14.

2014-01-23  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* ptftopl.ch: Slightly simplified.  Fixed some typos.

2014-01-22  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* ptrip/ptrip.diffs: Updated for pTeX 3.14159265.

2014-01-20  Peter Breitenlohner  <peb@mppmu.mpg.de>

	TeX tuneup of 2014.
	* ptex-base.ch: Adapt to TeX Version 3.14159265.
	* ppltotf.ch: Adapt to PLtoTF Version 3.6.
	* ptftopl.ch: Adapt to TFtoPL Version 3.3.

2014-01-17  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* ptrip.test (removed): Renamed ...
	* ptriptest (new): ... into this.
	* am/ptex.am: Adapted.

2013-12-31  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* ptftopl.ch, tests/min10.pl, tests/min10.pl: Don't write
	SEVENBITSAFEFLAG for JFM (yoko or tate) fonts.

2013-12-18  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* tests/min10.pl, tests/tmin10.pl: Converted to 7-bit ASCII.
	* yokotate.test: Simplified.

2013-12-17  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* ppltotf.ch: Drop one unused change set (is in ../pltotf.ch).
	Print DIRECTION value with print_ln() instead of err_print().

2013-11-18  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* ptex-base.ch: Simplify a few change sets.

2013-08-12  TANAKA Takuji <KXD02663@nifty.ne.jp>

	* kanji.h, ptex-base.ch, ptex.defines: Allow file names with 0x5c in
	(e)pTeX on Windows.

2013-06-18  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* am/ptex.am: Move PTEXENC_RULE to ../Makefile.am.

2013-06-05  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* kanji.h: Avoid redefinition of KANJI.

2013-05-05  Hironori Kitagawa  <h_kitagawa2001@yahoo.co.jp>

	* ptex-base.ch: Fix a bug that KANJI info of the last char in \hbox
	was lost.

2013-04-09  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* ptrip/ptrip.diffs: Update for TL 2013.

2013-04-09  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* ptex-base.ch: 3.3 ---> 3.4 for TL 2013.

2013-03-04  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* am/ptex.am: Better rule for ptex_version.h.

2013-02-15  Peter Breitenlohner  <peb@mppmu.mpg.de>

	Avoid spurious failures of parallel tests.
	* am/ptex.am, nissya.test, pbibtex.test, pdvitype.test,
	ppltotf.test, ptftopl.test, sample.test, yokotate.test:
	Change directory for temporary files from tests to ptests.
	* pbibtex-longline-test.pl: Use plongline.aux as input together
	with longline.bib from source tree.

	* pbibtex-openout-test.pl: Fix the input file location.

2013-01-15  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* am/ptex.am, pbibtex-mem.test, ptrip.test:
	Enable parallel-tests.

2013-01-04  Hironori Kitagawa  <h_kitagawa2001@yahoo.co.jp>

	* ptex-base.ch: \xkanjiskip around math_node etc.

2012-12-16  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* am/ptex.am (ptex_version.h): Enable silent rules.

2012-11-11  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* ptex-base.ch: Remove native buffer printing code.

2012-11-10  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* ptex-base.ch (cs_error): Remove "endmubyte" code.

2012-08-22  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* ppltotf.ch: Remove putc kludge, convert knows (u)ppltotf.

	* kanji.c (init_default_kanji): Set defaults before testing
	PTEX_KANJI_ENC from the environment.
	* kanji.c: WIN32 defaults differ, except for pBibTeX.

2012-07-19  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* am/ptex.am: Distribute ptex_version.h.

2012-07-17  Hironori Kitagawa  <h_kitagawa2001@yahoo.co.jp>

	* ptex-base.ch: fix a bug in
	@<Scan an alphabetic character code into |cur_val|@>

2012-07-15  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* pbibtex.ch, pdvitype.ch, ppltotf.ch, ptftopl.ch:
	Adapt to the use my_name.

2012-07-15  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* ptexextra.c: Must #define DLLPROC before reading ptexd.h.

2012-06-30  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* ptexextra.c [W32TeX]: #define DLLPROC for ptex.dll.

2012-05-22  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* pdvitype.test, sample.test: Cope with spaces in paths returned
	by kpsewhich.

2012-05-12  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* ptex-base.ch: Restore the 'unnecessary and seemingly wrong'
	changes; they are required to show the error context.
	* ptrip/ptrip.diffs: Adapted.

2012-05-11  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* ptex-base.ch (pTeX_version_string): Version 3.3.
	* ptrip/ptrip.diffs: Adapted.

2012-03-11  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* ptex-base.ch: remove unnecessary and seemingly wrong changes

2012-03-08  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* ptex-base.ch: fix a long-remained bug in show_context.

2012-03-04  Peter Breitenlohner  <peb@mppmu.mpg.de>

	Avoid 'differ in signedness' warnings.
	* pbibtex.ch, ppltotf.ch: Use ustringcast(buffer).
	* ptex-base.ch: Use ustringcast for buffer and str_pool.

2012-01-22  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* ptftopl.ch: Adapt to missing space added in ../tftopl.ch.

2012-01-07  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* pdvitype.ch: Remove an unnecessary change in previous.

2012-01-05  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* kanji.h, pdvitype.ch: enable -kanji option in pdvitype.
	(patch from TANAKA Takuji-san).

2011-12-19  Hironori Kitagawa  <h_kitagawa2001@yahoo.co.jp>

	* ptex-base.ch, ptex.defines, kanji.[ch]: Avoid Segmentation
	fault for japanese \catcode or \kcatcode.

2011-12-08  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* ptex-base.ch: Ensure that `hi(#)==#'.

2011-11-25  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* am/ptex.am (pdvitype_CPPFLAGS): Replace '-DDHEX_CHAR_CODE' by
	'-DHEX_CHAR_CODE'.

2011-10-04  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* am/ptex.am (DISTCLEANFILES): Preserve distributed files.

2011-08-29  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* pbibtex.ch: Use nil, not 0 as arg of set_enc_string().

2011-08-23  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* pbibtex.ch, pdvitype.ch, ppltotf.ch, ptftopl.ch, ptex.defines:
	Change init_default_kanji => init_kanji.
	* kanji.[ch]: Map initdefaultkanji (for pTeX and e-pTeX) and
	initkanji (for pBibTeX, pDVItype, pPLtoTF, and pTFtoPL) to
	init_default_kanji() with two encoding string arguments.

2011-08-22  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* pbibtex.ch, pdvitype.ch, ppltotf.ch, ptftopl.ch: Change error
	message text 'kanjicode encoding' => 'kanji encoding'.
	* am/ptex.am (*_DEPENDENCIES): Define proper dependencies.

2011-08-20  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* pbibtex.ch, ppltotf.ch, ptftopl.ch: Stop parsing arguments at
	"-version" and immediately call print_version_and_exit().

2011-08-19  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* pbibtex.ch, pdvitype.ch, ppltotf.ch, ptftopl.ch: Add WIN32
	option "sjis-terminal" and init_default_kanji().
	* ptex.defines: Add sjisterminal and initdefaultkanji.
	* kanji.[ch]: Add support for WIN32 option "sjis-terminal".
	(check_kanji): Change return type boolean => int (for -1, 0, +1).
	(initdefaultkanji): New function from W32TeX kanjiextra.c.
	* am/ptex.am (*_LDADD): Use libkanji.a for all binaries.

	* pdvitype.ch: Change banner 'PDVItype' => 'pDVItype'.
	* ppltotf.ch: Change banner 'Nihongo PLtoTF' => 'pPLtoTF'.
	More fix usage ('progname').  Simplify kanji encoding output.
	* ptftopl.ch: Change banner 'Nihongo TFtoPL' => 'pTFtoPL'.
	More fix usage ('progname').  Simplify kanji encoding output.
	* pbibtex.ch: Simplify kanji encoding output.

2011-08-19  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* ppltotf.ch, ptftopl.ch: fix usage ('progname').

2011-08-18  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* pbibtex.ch, pdvitype.ch, ppltotf.ch, ptftopl.ch: Add WIN32
	option "sjis-terminal" and init_default_kanji().
	* ptex.defines: Add sjisterminal and initdefaultkanji.
	* kanji.[ch]: Add support for WIN32 option "sjis-terminal".
	(check_kanji): Change return type boolean => int (for -1, 0, +1).
	(initdefaultkanji): New function from W32TeX kanjiextra.c.
	* am/ptex.am (*_LDADD): Use libkanji.a for all binaries.

2011-08-18  Peter Breitenlohner  <peb@mppmu.mpg.de>

	pTeX update tlsvn23478-uptex-1108111825 [ptex:00267]
	from Hironori Kitagawa <h_kitagawa2001@yahoo.co.jp>

	* ptex-base.ch: Merged with ptex-20110723-nullfont.ch (bug fix).

2011-08-12  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* ptex-base.ch: Slightly reformulate to simplify e-upTeX.

	* kanji.h [MP]: Remove TEXMFPOOLNAME and TEXMFENGINENAME.

2011-07-04  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* am/ptex.am (pweb_tests): New variable for tests of pTeX
	related Web programs (split off ptex_tests).

	* ptrip/texmf.cnf (main_memory): Increase for SyncTeX.

2011-06-30  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* am/ptex.am (ptex_ch_srcs): SyncTeX infrastructure.
	* ptex-base.ch: Slightly reformulate to simplify SyncTeX.

2011-04-19  Peter Breitenlohner  <peb@mppmu.mpg.de>

	Avoid 'differ in signedness' warnings.
	* ptex-base.ch: Cast buffer and str_pool to string when used as
	arg of multistrlen() or fromBUFF().
	(pack_buffered_name): Drop change already done in ../tex.ch.

	* pbibtex.ch: Cast buffer to string when used as a arg of
	input_line2().

	* ppltotf.ch: Cast buffer to string when used as a arg of
	input_line2() or multistrlen().

2011-04-15  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* ptex-base.ch: Add \ifdbox and \ifddir,
	(pTeX_version_string) Version p3.2.

2011-03-31  Hironori Kitagawa  <h_kitagawa2001@yahoo.co.jp>

	* ptex-base.ch: TeX formatting.

2011-03-30  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* ptex-base.ch: Handle disp_node from discretionary.

2011-03-29  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* ptex-base.ch: Redefine box_dir to also work for
	min_quarterword<0.

2011-03-28  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* am/ptex.am: Use AM_CFLAGS instead of {libkanji_a,ptex}_CFLAGS.

2011-03-27  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* ptex-base.ch: Reformulate @<Fetch an item in the current
	node...@>, begin_box, and delete_last to fix a bug in
	\lastpenalty & Co; further reduce e-pTeX interferences.

2011-03-26  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* ptex-base.ch: Fix a bug in begin_box introduced on 2011-03-24,
	mail from Hironori Kitagawa, Sat, 26 Mar 2011 21:42:49.

2011-03-24  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* ptex-base.ch: Reformulate begin_box and delete_last to reduce
	interferences between e-TeX and pTeX.

2011-03-22  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* ptex-base.ch: Reformulate @<Fetch an item in the current
	node...@> to reduce interferences between e-TeX and pTeX.

2011-03-18  Peter Breitenlohner  <peb@mppmu.mpg.de>

	e-pTeX update eptex-110315_tlsvn110318.diff [ptex:00248]
	from Hironori Kitagawa <h_kitagawa2001@yahoo.co.jp>

	* ptex-base.ch: Define and use the Web macro set_box_dir
	to reduce interferences between e-TeX and pTeX.
	Fixed a bug around \radical with Japanese character.
	Fixed a bug in setting/reading a dimension of a box register in
	"different" directions.

2011-01-19  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* ptex-base.ch: Let \lastkern etc act through disp node.
	Define dir_yoko as 4 and not qi(4); dir_field and adj_dir_field
	are -dir_yoko..dir_yoko and not -dir_dtou..dir_dtou.
	Shorten change sets. Remove trailing blanks.

2011-01-17  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* ptex-base.ch: banner_k==banner for pTeX.

	* am/ptex.am (ptrip.diffs): Use $(triptrap_diffs).

2011-01-14  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* am/ptex.am (ptrip-clean): Use TRIPTRAP_CLEAN.

2011-01-13  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* ptex-base.ch: Reformulate if_*_code definitions, for e-pTeX.

2011-01-12  Peter Breitenlohner  <peb@mppmu.mpg.de>

	Somewhat rearrange to simplify building e-pTeX:

	* ptex-base.ch: @d pTeX_version_string, use it for pTeX_banner
	but keep definition of TeX_banner.
	* am/ptex.am (ptex_version.h): Adapted.

	* ptex-base.ch: Rename cur_dir => cur_dir_hv to avoid conflict
	with cur_dir from e-TeX.
	Shorten or split the individual change sets to avoid conflicts.

2011-01-11  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* am/ptex.am: Build libkanji.c from kanji.c, for pTeX and e-pTeX.

	* kanji.h (epTeX): #define getintone(w) and setintone(w,a),
	and #include <ptexenc/unicode.h>,

2011-01-08  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* ptex-base.ch: Adapt to removal of encTeX changes from tex.ch.

2011-01-07  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* ptexextra.in: Renamed ...
	* ptexextra.h: ... into this; #include ptex_version.h
	for PTEX_VERSION.

	* ptexextra.c (new): #include <ptexd.h> and <lib/texmfmp.c>.

	* am/ptex.am: ptexextra.[ch] are now distributed;
	create ptex_version.h instead of ptex.version. 

2010-12-31  Hironori Kitagawa <h_kitagawa2001@yahoo.co.jp>

	* ptex-base.ch: Bug fix and accent Kanji.

2010-12-14  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* pbibtex.ch: Adapt to latest bibtex.web.

2010-11-04  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* ptex-base.ch (get_jfm_pos): Avoid accessing non-existent array
	elements that could cause segmentation faults.

2010-06-10  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* am/ptex.am (ptex_cppflags): Add $(AM_CPPFLAGS).

2010-05-25  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* Files, pbibtex.defines, ptex.mk, ptex-base.ch.orig,
	ptex-include.ch, ptexhelp.h, reautoconf (removed): Unused files.
	* am/ptex.am (EXTRA_DIST): Adjust.

2010-05-25  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* am/ptex.am (EXTRA_DIST): Remove tmf-pool.h.

2010-05-23  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* ptex-base.ch: Bug fix from
	Hironori Kitagawa <h_kitagawa2001@yahoo.co.jp>.

2010-05-21  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* am/ptex.am: Fix the lib/libp.a rebuild rule.

2010-05-11  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* nissya.test (new): Shell script for pBibTeX test using kanji.
	* tests/nissya_bib.aux, tests/nissya.bst, tests/sample.bib
	(new): Test data for nissya.test from Akira.
	* am/ptex.am: Add the new test.

2010-05-03  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* pdvitype.ch: Treat kanji chars for put[1-4] as for set[1-4].

2010-05-01  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* yokotate.test: Use ptftopl with '-charcode-format octal'.
	* ptftopl.ch: Correctly check glue indices.
	Use Web macros to access |char_type| table entries.
	Reformat CHARSINTYPE lists with shorter lines.

2010-04-30  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* pdvitype.test: Use installed cm fonts.
	* sample.test, yokotate.test (new): Shell scripts to test
	pDVItype and pPLtoTF/pTFtoPL with yoko and tate fonts.
	* tests/goth10.tfm tests/sample.dvi (new): Data for sample.test.
	* tests/{min10,tmin10}.{pl,tfm} (new): Data for yokotate.test.
	* am/ptex.am: Add the new tests.

2010-04-26  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* pbibtex.ch: Remove unused code 'Check if |max_print_line|...'.
	Akira Kakuto <kakuto@fuk.kindai.ac.jp>, 24 Apr 2010 12:10:13.

2010-04-23  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* pbibtex.ch, kanji.h: Use input_line2() with five arguments
	for correct handling of buffer_overflow.

	* pbibtex-longline-test.pl, pbibtex-openout-test.pl,
	pbibtex-mem.test, pbibtex.test: New tests.
	* am/ptex.am: Add them.

2010-04-22  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* pdvitype.ch: Remove unnecessary change.
	* ppltotf.ch: Adapt to bug fix now done in ../pltotf.ch,
	originally by Ken Nakano <nakano@nextsolution.co.jp>.
	* kanji.h (inputline2): Moved from ../../ptexenc/ptexenc.h to here.

	* pbibtex.ch: Correct handling of buffer_overflow.  From Akira.
	* ptex.defines (inputline3): Removed.

	* am/ptex.am: No synctex.  No reason to create ptexdir/lib/.

2010-04-21  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* pdvitype.test, ppltotf.test, ptftopl.test (new): Shell scripts
	for basic 'make check' tests.
	* am/ptex.am: Add these tests.

	* pbibtex.ch: Adapt to change (bug fix) in ../bibtex.ch.
	Remove kanji fix of workaround from ../bibtex.ch for breaking
	long lines in module 324; all that is gone with bibtex-0.99d.

2010-04-17  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* ppltotf.ch: Rename PTEX_PLTOTF_HELP => PPLTOTF_HELP.
	* ptftopl.ch: Rename PTEX_TFTOPL_HELP => PTFTOPL_HELP.
	* ptexhelp.h (removed): Help text now in ../help.h.
	* kanji.h: Remove #include "ptexhelp.h" and redefinition of
	TEXMFPOOLNAME and TEXMFENGINENAME.

	* ptexextra.in (PTEXHELP): Moved to ../texmfmp-help.h from here.

	* ptex.defines (inputline3): Moved from pbibtex.defines to here.
	(PTEXTFTOPLHELP, PTEXPLTOTFHELP, PDVITYPEHELP): Removed.
	* pbibtex.defines (removed): Using ptex.defines.
	* ptex-include.ch (removed): Now done in ../texmfmp.h.

	* am/ptex.am: Adjust and replace lib/lib.a by ../lib/libp.a.

2010-04-17  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* pdvitype.ch: New version, used on top of dvitype.ch.
	* ptftopl.ch, ptex-base.ch: Remove trailing whitespace.

	Avoid compiler warnings.
	* ptftopl.ch (organize): Slightly reformulate (uninitialized).
	* ppltotf.ch: Handle Pascal Web's char as in ../pltotf.ch.
	(todig): Change param type to byte. Don't return uninitialized.

2010-04-15  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* pbibtex.ch, ptex-base.ch, ptftopl.ch: Use conststringcast, not
	stringcast to cast the get_enc_string() value which is now const.
	* ptexhelp.h (PDVITYPEHELP): Fixed a typo in help message.

2010-04-14  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* pbibtex.ch: New version from Akira, used on top of bibtex.ch.
	Keep hack0 -- initialization of jump buffer.
	* am/ptex.am: Reworked.
	* ptexextra.in, ptexhelp.h: Declare based_prog_name as const.
	* ppltotf.ch: Fixed a typo.

2010-04-13  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* am/ptex.am: Fix for 'make dist' and 'make distcheck'.
	* ptrip.test: Simplify.
	* ptrip.diffs: Expected results from TRIP test for pTeX.
